// uiExampleBtnChkRadPixl.js - example w/ Btn, Chk and Radio on Pixl.js

// 20191030 - allObjects - vars: ~ / ~

// ----- setup lon and log() (considering emulating _eConsole)
var lon = true // logging is on / off
  , log = function() { if (lon) { var lgr;(lgr=(typeof _eConsole
       =="object")?_eConsole:console).log.apply(lgr,arguments);}};

// ----- pull in ui base and ui element(s) and extensions
var ui = require("ui")     // basic module
    .adx(require("uiEP3")) // 3 button controlled Pixl ui extension
    .adx(require("uiBtn")) // ui plain button element
    .adx(require("uiChk")) // ui check box element
    .adx(require("uiRad")) // ui radio button element
    .adx(require("Font6x8"),-2,"Font6x8") // pixl suitable bitmap font (fs=-1)
    ;

//----- define callback(s): preferred (untouch) / generic (all) touch events

var cb = function(id, v, _, e) { // preferred - untouch event only
           log("id:",id,"v:",v,((_.t)?"":"un")+"touch focused",_.x,_.y,_.t); }
  , ca = ( (typeof ca === "undefined") // generic - all touch events
         ? function(id, v, _, e) { var s=(_.f|65536).toString(2); // log flags
             log("c:",e[1],"c:",e[1],"id:",id,"v:",v,"f:"
                ,[s.substr(5,4),s.substr(9,4),s.substr(13,4)].join(" "),_.f); }
         : ca )
  , backlite = function(id, v, e) { // turn backlight on / off w/ label change
         digitalWrite(LED,v); // e[11][4]=(v)?"off":"on"; // set LED and label
         return false; } // return true/y in callback redraws ui elt & label(s)
  , u; // for space / memory / var saving value of * undefined *


// ----- create UI (executing definition in function requires less memory on upload)

var cui = function() { // invoke as 1st in onInit()

// ----- Pixl sepcific preparations ----------
ui.fl=(function(){ this.dsp.flip(); return this; }).bind(ui); // flip ui-bound
ui.bc=7; // set ui background color to white
ui.tc=0; // set ui touch color to black
ui.clrs= // set white to pixl color (light theme); dark theme: flip clrs: [(v&&4)?1:0]
  [function(c,i){ var v=(i)?c^7:c; return [(v&&4)?0:1]; }.bind(ui)
  ];

//---------- Button examples ----------
//....0  1     2       3   4   5   6   7   8  9       10  11                         12
//.flgs  clazz id      x   y   w   h  bc  fc  valObj  cb,  l (label array obj)
//       btn                ->x2->y2                        fs tc    x  y label txt  ca
ui.c( 3,"btn","b1"  ,  0,  0, 29, 21,  0,  0, "B_1",  cb,  [-1, 7,   7, 7, "Reg" ]);
ui.c( 3,"btn","b2"  , 28,  0, 39, 21,  0,  7, {v:2},  ca , [-1, 0,   7, 6, "BoYbg"],ca);
ui.c( 3,"btn","b3"  , 66,  0, 38, 14,  0,  7, 3    ,  cb , [ 0, 0,   8, 4, "Magnum"]);
ui.c( 3,"btn","b4"  ,103,  0, 25, 12,  0,  0, 4    ,  cb , [ 0, 7,   5, 3, "Tiny"]);

// ---------- Checkbox examples ----------
//....0  1      2      3   4   5   6   7   8  9       10  11                         12
//.flgs  clazz id      x   y   w   s  bc  fc  valObj  cb,  l (label array obj)
//       chk                ->x2+>y2~------->[s,vOjb]       fs tc    x  y label txt
ui.c( 3,"chk","c2"  , 67, 16, 13,  0,  0,  0, "X",    u ,  [-1, 0,   2, 3, "Up"   ], ca);
ui.c( 3,"chk","c1"  , 93, 16, 13,  1,  0,  7,true,backlite,[ 0, 0,   2, 8, "light"]);

// ---------- Radio button examples ----------
//....0  1     2       3   4   5   6   7   8  9       10  11                         12
//.flgs  clazz id.grp  x   y   w   s  bc  fc   valObj cb,  l (label array obj)
//       rad                ->x2+>y2~------->[s,vOjb][g,cb,]fs tc    x  y  label txt ca
ui.c( 3,"rad","r1.a",  0, 23, 23,  0,  0,  0, "L",    cb,  [ 0, 0,   2, 9, "Large"]);
ui.c( 3,"rad","r1.b", 47, 26, 17,  1,  0,  0, "M",    0 ,  [ 0, 0,   2, 7, "Med"  ]);
ui.c( 3,"rad","r1.c", 81, 31, 11,  1,  0,  0, "S",    0 ,  [ 0, 0,   2, 3, "Small"]);
};

//---------- extra drawings examples ----------
var xDs = function(ui) { // e (2nd arg of no use on draw all)
  ui.dl([0,0,108, 16, "back"]);
};

//----- Pixl specific
var dsp = g; // ...to keep var names to same in all examples

// ----- run UI
function onInit() {
  cui(); // create ui
  dsp.clear(); LED.set(); // display clear and turn back light on
  setTimeout(function(){
    // connect ui to dsp and display it
    ui.connect(dsp,BTN3,BTN4,BTN1)
      .dr(1)      // wipe screen w/ background color using draw rect
      .d(0,xDs)   // display all elements
      .fl()       // display flip
      .di = true; //  set display draw / changes to immediate
  },1000);
}
