// uiExampleBtnPixl.js - uiBtn - button on pixl - example

// 20191108 - allObjects - vars: ~ / ~ 

// ----- setup lon and log() (considering emulating _eConsole)
var lon = true // logging is on / off
  , log = function() { if (lon) { var lgr;(lgr=(typeof _eConsole
       =="object")?_eConsole:console).log.apply(lgr,arguments);}};

// ----- pull in ui base and ui element(s) and extensions
var ui = require("ui")     // basic module (ncommented)
    .adx(require("uiEP3")) // 3 button controlled Pixl ui extension
    .adx(require("uiBtn")) // ui plain button element
    .adx(require("Font6x8"),-2,"Font6x8") // pixl suitable bitmap font (fs=-1)
    ;


// ----- define callback(s): preferred (untouch) / generic (all) touch events

var cb = function(id, v, _, e) { // preferred - untouch event only
           log("id:",id,"v:",v,((_.t)?"":"un")+"touch focused",_.x,_.y,_.t); }
  , ca = ( (typeof ca === "undefined") // generic - all touch events
         ? function(id, v, _, e) { var s=(_.f|65536).toString(2); // log flags
             log("c:",e[1],"c:",e[1],"id:",id,"v:",v,"f:"
                ,[s.substr(5,4),s.substr(9,4),s.substr(13,4)].join(" "),_.f); }
         : ca )
  , backlite = function(id, v, e) { // turn backlight on / off w/ label change
         digitalWrite(LED,v); // e[11][4]=(v)?"off":"on"; // set LED and label
         return false; } // return true/y in callback redraws ui elt & label(s)
  ;


//----- create UI - exec def in function(s) requires less memory on upload

var cui = function() { var u = undefined; // invoke as 1st in onInit()

//---------- Button examples ----------
//
//....0  1     2       3   4   5   6   7   8  9       10  11                            12
//.flgs  clazz id      x   y   w   h  bc  fc  valObj  cb,  l (label array obj)
//       btn                ->x2->y2                        fs tc    x  y label txt     ca
  ui.c( 3,"btn","b1"  ,  0,  0, 28, 19,  0,  0, "B_1",  cb,  [-1, 7,   6, 6, "RED" ]);
  ui.c( 3,"btn","b2"  , 27,  0, 43, 19,  0,  7, {v:1},  ca , [-1, 0,   6, 6, "BonYbg"], ca);

};

// ----- Pixl specific
var dsp = g; // ...to keep var names to same in all examples

// ----- run UI
function onInit() {
  dsp.clear(); LED.set(); // display clear and turn back light on
  setTimeout(function(){
    // connect ui to dsp and enter, next prev buttons and display ui
    ui.connect(dsp,BTN3,BTN4,BTN1)
      .dr(1)      // wipe screen w/ background color using draw rect
      .d()        // display all elements
      .fl()       // display flip
      .di = true; //  set display draw / changes to immediate
  },1000);
}
