// uiExampleChk.js - uiChk - check box - example

// 20190927 - allObjects - vars: ~ / ~

// Check boxes of all sizes; example pulled from uiExampleChkPixl for
// validation in 294x320 TTF display. Untypical for TTF is the white
// background color - to make chekcboxes behave like on Pixl B&W LCD.
// NB: Only the larges check box is autally usable - because dpi of
// TTF is much higher.

// ----- setup lon and log() (considering emulating _eConsole)
var lon = true // logging is on / off
  , log = function() { if (lon) { var lgr;(lgr=(typeof _eConsole
       =="object")?_eConsole:console).log.apply(lgr,arguments);}};

// ----- pull in ui base and ui element(s)
var ui = require("ui")
    .adx(require("uiChk"))
    ;

// make ui adjustments for example (colors, visibility)
ui.bc=7; // white background color to get behavior of Pixl B&W LCD.
ui.tc=0; // black touch / focus color to get behavior of Pixl B&W LCD.

// ----- define callback(s): log ui element id and value (only)
var cb = function(id, v, _, e, t) { log( "id:",id,"val:",v
        ,(t)?((t.t)?"":"un")+"touch focused":t); }
  , ca = ( (typeof ca === "undefined")
         ? function(id, v, _, e, t) { var s=(t.f|65536).toString(2); // log flags
             log("id:",id,"v:",v,"f:",[s.substr(5,4),s.substr(9,4),s.substr(13,4)].join(" "),t.f); }
         : ca )
  , backlite = function(id, v, e, t) { // turn backlight on / off w/ label change
         // commented, becaise TTF is illegible when no backlith present
         // alternative is to ise PWM to switch between bright and dim...
         // digitalWrite(A1,v); // e[11][4]=(v)?"off":"on"; // set LED and label
         return false; } // return true/y in callback redraws ui elt & label(s)
  , u; // for space / memory / var saving value of * undefined *

// ----- define UI (in level 0 - built to be saved)

// ---------- Checkbox examples ----------
//    0  1      2      3   4   5   6   7   8  9       10  11                         12
// flgs  clazz id      x   y   w   s  bc  fc  valObj  cb,  l (label array obj)
//       chk                ->x2+>y2~------->[s,vOjb]       fs tc    x  y label txt
//---------- Checkbox examples ----------
//    0  1      2      3   4   5   6   7   8  9       10  11
// flgs  clazz id      x   y   w   s  bc  fc  valObj  cb,  l (label array obj)
//       chk                ->x2->y2~------->[s,vOjb]       fs tc    x  y  label txt ca
var s = 0;
ui.c( 3,"chk","cA"  ,  0,  2,  9,  s,  0,  7,true,backlite,[ 0, 0,   1, 2,  "5|9" ]);
ui.c( 3,"chk","cB"  ,  0, 16, 11,  s,  0,  7,true,backlite,[ 0, 0,  -5,11,  7     ]);
ui.c( 3,"chk","cC"  , 10, 14, 13,  s,  0,  7,true,backlite,[ 0, 0,  -6,13,  9     ]);
ui.c( 3,"chk","cD"  , 22, 11, 16,  s,  0,  7,true,backlite,[ 0, 0, -10,16, 12     ]);
ui.c( 3,"chk","cE"  , 37,  8, 19,  s,  0,  7,true,backlite,[ 0, 0, -12,19, 15     ]);
ui.c( 3,"chk","cF"  , 55,  5, 22,  s,  0,  7,true,backlite,[ 0, 0, -13,22, 18     ]);
ui.c( 3,"chk","cG"  , 76,  3, 24,  s,  0,  7,true,backlite,[ 0, 0, -14,24, 20     ]);
ui.c( 3,"chk","cH"  , 99,  0, 27,  s,  0,  7,true,backlite,[ 0, 0, -22,27, "23|27"]);
ui.c( 3,"chk","ca"  ,  0, 53,  9,  s,  0,  0,true,backlite,[ 0, 0,   1, 2, "5|9"  ]);
ui.c( 3,"chk","cb"  ,  0, 33, 11,  s,  0,  0,true,backlite,[ 0, 0,  -8,11, 11     ]);
ui.c( 3,"chk","cc"  , 10, 33, 13,  s,  0,  0,true,backlite,[ 0, 0,  -9,13, 13     ]);
ui.c( 3,"chk","cd"  , 22, 33, 16,  s,  0,  0,true,backlite,[ 0, 0, -11,16, 16     ]);
ui.c( 3,"chk","ce"  , 37, 33, 19,  s,  0,  0,true,backlite,[ 0, 0, -12,19, 19     ]);
ui.c( 3,"chk","cf"  , 55, 33, 22,  s,  0,  0,true,backlite,[ 0, 0, -13,22, 22     ]);
ui.c( 3,"chk","cg"  , 76, 33, 24,  s,  0,  0,true,backlite,[ 0, 0, -14,24, 24     ]);
ui.c( 3,"chk","ch"  , 99, 33, 27,  s,  0,  0,true,backlite);


// add check boxes in larger size - not suitable for Pixl because of dpi / resolution;
// add them in the 'pushed to border' fashion lick above and sift them laater into
// area sitable for touch screen usage.
ui.c( 3,"chk","cI"  , 0,  70, 35,  s,  0,  7,true,backlite,[ 0, 0, -26,35, "31|35"]);
ui.c( 3,"chk","ci"  ,40,  70, 35,  s,  0,  0,true,backlite,[ 0, 0, -26,35, "31|35"]);


// make ui adjustments for example (position fo touchability)
ui.es.forEach(function(e){ e[3]+=30; e[4]+=30; e[5]+=30; e[6]+=30; });


//----- pull in display w/ width / height and touch screen
var dsp,   dspMod   = require("ILI9341"), dspW=240, dspH=320
  , touch, touchMod = require("XPT2046")
  ;
// ----- run UI
function onInit() {
  SPI2.setup({sck:B13, miso:B14, mosi:B15, baud: 1000000});
                     // spi,  dc, cs, rst, callback
  dsp = dspMod.connect(SPI2, B10, B1,  A4, function() {
    dsp.clear(); A1.set(); // display clear and turn back light on
    // connect ui to dsp and display it
    ui.connect(dsp)
      .w(0,0,dspW-1,dspH-1) // wipe screen (rect) w/ background color
      .d()                  // display all elements
      .di = true;           // set display changes to immediate
    // setup touch screen and connect it to ui
    SPI1.setup({sck:A5, miso:A6, mosi:A7, baud: 2000000});
                           // spi, cs, irq, callback, calc (calibrated)
    touch = touchMod.connect(SPI1, A3,  A2, function(x,y){ ui.evt(x,y);}
        , function(yr, xr, d) {
            return [ Math.round(xr / -121.44          + 259.70685111989) 
                   , Math.round(yr /   88.90357142857 + -19.78130398103)
                   ];
    }).listen();
  });
}

setTimeout(onInit,999); // for dev only, remove before upload for save()
