// uiExampleAll.js - example with all ui elements

// 20191103 - allObjects - variables:  /  / 

// Example includes ui control w/ physical push buttons vs touch screen.

// ----- setup lon and log() (considering emulating _eConsole)
var lon = true // logging is on / off
  , log = function() { if (lon) { var lgr;(lgr=(typeof _eConsole
       =="object")?_eConsole:console).log.apply(lgr,arguments);}};

// ----- pull in ui base and ui element(s)
var ui = require("ui")
    .adx(require("uiBtn"))
    .adx(require("uiChk"))
    .adx(require("uiSli"))
    .adx(require("uiExt")) // prereq for ui control w/ buttons vs touch screen
    .adx(require("uiEBC")) // prereq for ui control w/ buttons vs touch screen
    .adx(require("uiEBT")) // prereq for ui control w/ buttons vs touch screen for Tap / Enter
    ;
ui.clrs = // imply color depth and table w/ converter and define user colors / palette
  [function(c,i) { // color info to [r,g,b] converter at index 0 (ui.clrs[0](...))
      var v, s=isNaN(c); if (s || c<0) { // c<0 (looked up [R,G,B]) or c=[R,G,B]
        return (((s) ? c : this.clrs[-c]).map(function(v){ return ((i)?v^255:v)/256; }));
      } else { // c>=0 bit coded rgb color (default 1 bit color depth 2^1^3=8 colors)
        v = (i) ? c^7 : c; return [v>>2&1,v>>1&1,v&1]; } }.bind(ui)
  ,[216,216,216] // user color -1: light grey // keyboard bottom right special keys
  ,[192,192,192] // user color -2: medium light grey
  ,[128,128,128] // user color -3: medium gray
  ,[192,128,192] // user color -4: light purple
  ,[0  ,160, 64] // user color -5: kind of a 'darker' green
  ];

// ----- define callback(s): preferred (untouch) / generic (all) touch event(s)
var cb = function(id, v, _, e) { log( "id:",id,"val:",v
         ,((_.t)?"":"un")+"touch"); }
  , ca = ( (typeof ca === "undefined")
         ? function(id, v, _, e) { var s=(_.f|65536).toString(2); // log flags
             log("c:",e[1],"c:",e[1],"id:",id,"v:",v,"f:",[s.substr(5,4),s.substr(9,4),s.substr(13,4)].join(" "),_.f); }
         : ca )
  , u; // for space / memory / var saving value of * undefined *


//beat - non-oo
var bW,bTop,bBot // width,top,bottom
  , bIId = null  // interval id
  , bInd = 1     // index
  , bCnt = 4     // count
  , bWin = 0     // 'window'
  , bWOf = 0     // 'window' offset
  , bStart = function() {
      bW = ui.dsp.getWidth();
      bTop = 27
      bBot = 58
      bCnt = cnt[9];
      bWin = ui.mf(bW/bCnt)
      bInd = 0;
      bWOf = 2;
      ui.clr(ui.bc).dsp.fillRect(0,0,bW-1,bTop-1);
      ui.clr(7).fnt(18); for (var i=1;i<=bCnt;i++) ui.dsp.drawString(i,(i-1)*bWin+2,0);
      ui.clr(6).dsp.fillRect(0,bTop,bW-1,bBot);
      bIId = setInterval(bBeat,60000/tmp[9]);
    }
  , bStop = function() {
      bIId = clearInterval(bIId);
      ui.clr(ui.bc).dsp.fillRect(0,0,bW-1,bBot);
    }
  , bBeat = function() {
      if (++bInd<bCnt) {
        ui.clr(ui.bc).dsp.fillRect(bWOf,bTop+1,(bWOf+=bWin)-2,bBot-1)
      } else {
        bInd = 0; bWOf = 2;
        ui.clr(6).dsp.fillRect(0,bTop,bW-1,bBot);
      }
    }
  ;

var ss = function(id,v,_,e) { e[11][4]=(e[9]=(v)?0:1)?"Stop":"Start"; // toggle text
                                                 cb(id,v,_,e);
                                                 setTimeout((v) ? bStop : bStart, 10);
                                                 return true;  } // start/stop callback
  , tb = function(id,v,_,e) {                    cb(id,v,_,e); } // bell on/off
  , tv = function(id,v,_,e) {                    cb(id,v,_,e); } // vibrate on/off
  , ct = function(id,v,_,e) {  e[9]=(v=_.mr(v)); ca(id,v,_,e); } // tempo callback
  , cc = function(id,v,_,e) {  e[9]=(v=_.mr(v)); ca(id,v,_,e); } // count callback
  ;

//----- create UI (executing definition in function requires less memory on upload)

var tmp // temp
  , cnt // count (beats per bar)
  , cui = function() { var u = undefined; // invoke as 1st in onInit()

//---------- Check box examples ----------
//
//....0  1     2       3   4   5   6   7   8  9       10  11                         12
//.flgs  clazz id      x   y   w   s  bc  fc  valObj  cb,  l (label array obj)
//       chk                ->x2+>y2~------->[s,vObj]       fs tc    x  y  label txt
ui.c( 3,"chk","bb"  ,  3, 62, 25,  0, -5,  7, 0,      tb,  [14, 7,   4, 5, "Bell" ]);
ui.c( 3,"chk","bv"  , 70, 62, 25,  0, -5,  7, 0,      tv,  [14, 7,   4, 5, "Vibrate" ]);

//---------- Button examples ----------
//
//....0  1     2       3   4   5   6   7   8  9       10  11                         12
//.flgs  clazz id      x   y   w   h  bc  fc  valObj  cb,  l (label array obj)
//       btn                ->x2->y2                        fs tc    x  y  label txt c
ui.c( 3,"btn","bt"  ,158, 62, 75, 29,  5,  6, 0,      ss,  [14, 0,  18, 5, "Start"]);

// ---------- Slider examples ----------

tmp =
// non-pixl:
//....0  1     2       3   4   5   6   7   8  9       10  11                         12
//.flgs  clazz id      x   y   w   h  bc fcs  value   cb, ls (arr of labels ([[...],..]))
//       sli                ->x2->y2                    [0] fs tc    x  y  txt fmt
ui.c( 3,"sli","st"  ,  3, 96,234, 32, -4,[-4,0],60,   ct, [[12, 6,  92,12, u
                                                           ,function(v,_,l){ // v,ui,labl
       var s="", f=_.f; return [(!(f===0 || f&184)) ? s : s+_.mr(v)+" bpm"]; } // integer
//                                                          min max si  o a flgs
                                                           , 40,208,[3],0,0, 168
//                                                          left top right bot margins
                                                           ,  18,  6,   27]
//                                                     [>0] fs tc    x  y  txt fmt
                                                          ,[12, 7,   2,12,  "40"] // frnt
                                                          ,[12, 7, 207,12, "208"] // back
                                                          ]);

cnt =
// non-pixl:
//....0  1     2       3   4   5   6   7   8  9       10  11                         12
//.flgs  clazz id      x   y   w   h  bc fcs  value   cb, ls (arr of labels ([[...],..]))
//       sli                ->x2->y2                    [0] fs tc    x  y  txt fmt
ui.c( 3,"sli","sc"  ,  3,140,234, 32, -4,[-4,0], 4,   cc, [[12, 6, 101,12, u
                                                           ,function(v,_,l){ // v,ui,labl
       var s="", f=_.f; return [(!(f===0 || f&184)) ? s : s+_.mr(v)+" bpb"]; } // integer
//                                                          min max si  o a flgs
                                                           ,  2, 12,[3],0,0, 168
//                                                          left top right bot margins
                                                           ,   9,  6,   18]
//                                                     [>0] fs tc    x  y  txt fmt
                                                          ,[12, 7,   2,12,   "2"] // frnt
                                                          ,[12, 7, 216,12,  "12"] // back
                                                          ]);

};

//---------- extra drawings ----------
//
// function for extra / complementary drawings on initial and re-drawings
// of display,  such as:
var xDs = function(ui) { // e (2nd arg of no use on draw all)
  var d = ui.dsp; // display - Espruino Graphics object

  // - ticks for slider tmp - ui elt with id "st" (that has top margin to put them)
  var e = tmp          // get slider w/ id s2c as ui element e
    , m = e[11][0]     // to access margins 12,13,14/left,top,right
    , b = e[3]+2+m[12]      // start of slider bar (border, value 0)
    , l = e[4]+2+m[13]      // get e's top-1=y-1=lower y of tick (1 pixel above  bar)
    , w = e[5]-2-m[14]-b-1  // get e's slider bar width (right border (-1?), val 100)
    , v = w/(m[7]-m[6])     // pixels per bpm
    , u = l-6   // upper y of tick, use all 4 margin pixels betw. bar & sel/focus line
    , t // tick pos
    ;
  console.log("inc_val:",v);
  ui.clr(e[7]); // same as slider bar's border color
  for (var i=m[6];i<=m[7];i+=4) {
    t = ui.mr(b + (i-m[6]) * v) + 0.5; // weird +0.5, only in emulation / canvas
    console.log(i,t,l);
    d.drawLine(t,l,t,u+((i % 10)?3:0)); // short (2px) and long (4px) ticks
  }
  // - ticks for slider cnt - ui elt with id "sc" (that has top margin to put them)
  var e = cnt          // get slider w/ id s2c as ui element e
    , m = e[11][0]     // to access margins 12,13,14/left,top,right
    , b = e[3]+2+m[12]      // start of slider bar (border, value 0)
    , l = e[4]+2+m[13]      // get e's top-1=y-1=lower y of tick (1 pixel above  bar)
    , w = e[5]-2-m[14]-b-1  // get e's slider bar width (right border (-1?), val 100)
    , v = w/(m[7]-m[6])     // pixels per bpm
    , u = l-6   // upper y of tick, use all 4 margin pixels betw. bar & sel/focus line
    , t // tick pos
    ;
  console.log("inc_val:",v);
  ui.clr(e[7]); // same as slider bar's border color
  for (var i=m[6];i<=m[7];i++) {
    t = ui.mr(b + (i-m[6]) * v) + 0.5; // weird +0.5, only in emulation / canvas
    console.log(i,t,l);
    d.drawLine(t,l,t,u+((i % 2)?3:0)); // short (2px) and long (4px) ticks
  }

/// ...more extra drawings...
// ..
// .
};


// ----- pull in display w/ width / height and touch screen
var dsp,   dspMod   = require("ILI9341"), dspW=240, dspH=320
  , touch, touchMod = require("XPT2046")
  ;

// ----- run UI
function onInit() { // on power on/save() setting up all from scratch
  cui(); // create ui
  // setup and connect display, then ui and input (touch | phys btns)
  SPI2.setup({sck:B13, miso:B14, mosi:B15, baud: 1000000}); // display
  dsp = dspMod.connect(SPI2, B10, B1,  A4, function() { // using...
                  // ...spi,  dc, cs, rst, callback
    dsp.clear(); A1.set();  // display clear and turn back light on
    ui.connect(dsp) // connect ui to dsp and display it
      .dr(1)        // wipe screen (rect) w/ default / bg color
      .d(u,xDs)     // display all elements and extra drawings
      .di = true;   // set display changes to immediate
    SPI1.setup({sck:A5, miso:A6, mosi:A7, baud: 2000000}); // touch inp
    touch = touchMod.connect(SPI1, A3,  A2, function(x,y){ ui.evt(x,y);}
                        // ...spi, cs, irq, callback, /. calibrated...
        , function(yr, xr, d) { // ...function, maps touch to x/y of dsp
            return [ Math.round(xr / -121.44          + 259.70685111989) 
                   , Math.round(yr /   88.90357142857 + -19.78130398103)
                   ];
    } ).listen(); // for XPT2046 module (ADS7843: not needed/supported)
  } );
} // /onInit()

setTimeout(onInit,999); // for dev only, remove before upload for save()
