// TFT24TRCcalib.js

// 20190919 - allObjects - variables:  /  / 

// 2.4" 240x320 262K Color TFT LCD ILI9341 on SPI1 with 
// Resistive Touch Screen Controller XPT2046 on SPI2
//
// Wiring:
//  2.4"
//  DSP                  PICO [<---USB
//   1   VCC      red     3   3.3            shared
//   2   GND      blk     1   GND            shared
//   3   CS       blu     7   B6   CS        LCD
//   4   RST      brn     9   A8   reset RST LCD
//   5   D/C      grn     8   B7   D/C       LCD
//   6   MOSI     ylw     6   B5   SPI1 MOSI LCD
//   7   SCK      wht     4   B3   SPI1 SCK  LCD
//   8   LED      org    18   A5   LED       LCD
//   9   MISO     grn     5   B4   SPI1 MISO LCD
//  10   T_CLK    wht    23   B13  SPI2 SCK  Touch
//  11   T_CS     ylw    22   B10  CS        Touch
//  12   T_MOSI   grn    25   B15  SPI2 MOSI Touch
//  13   T_MISO   blu    24   B14  SPI2 MISO Touch
//  14   T_IRQ    blk    21   B1   IRQ       Touch

var dW = 240, dH = 320, dsp, dMod = require("ILI9341"),
    tSPI=SPI2, tCs = B10, tIrq = B1, 
    touch, tMod = require("ADS7843");

function mrkr(d,x,y,s) {
  dsp.setColor(1,1,1);
  dsp.drawRect(x-s,y-s,x+s,y+s);
  dsp.drawLine(x-s,y,x+s,y);
  dsp.drawLine(x,y-s,x,y+s);
}

function onInit() {
  A5.set();
  SPI1.setup({sck:B3, miso:B4, mosi:B5, baud: 1000000});
                   // spi, dc, cs, rst, callback
  dsp = dMod.connect(SPI1, B7, B6, A8, function() {
      dsp.clear();
      mrkr(dsp, 20, 20,9); mrkr(dsp,220,  20,9);
      mrkr(dsp,220,300,9); mrkr(dsp, 20, 300,9);
      mrkr(dsp,110,150,9);
      SPI2.setup({sck:B13, miso:B14, mosi:B15, baud: 2000000});
      var xs = [], ys = [];
      touch = tMod.connect(
          // spi, cs, irq, offsetx, offsety, w, h, callback // landscape
          SPI2, B10, B1,   -10,   6, dH, dW, function(yt, xt) {  // portrait
            if (yt !== undefined) {
          xs.push(dW - xt); ys.push(yt);
        } else {
            console.log((Math.floor(getTime() * 1000)).toString().substr(-3),
              Math.round(xs.reduce(function(p,c) { return p + c; },0)/xs.length),
              Math.round(ys.reduce(function(p,c) { return p + c; },0)/ys.length));
          xs = []; ys = [];
        }
      });
  });
}
onInit();
