// touchOnly1.js - XPT2046 module test

// 20190919 - allObjects - variables:  /  / 

//  2.4" 240x320 262K Color TFT LCD ILI9341 on SPI1 with 
//  Resistive Touch Screen Controller XPT2046 on SPI2
//  using out of box ILI9341 and custom XPT2046 modules.
//
// Wiring:
//  2.4"
//  DSP                  PICO [<---USB
//   1   VCC      red     3   3.3            shared
//   2   GND      blk     1   GND            shared
// ...
//  10   T_CLK    wht    23   B13  SPI2 SCK  Touch
//  11   T_CS     ylw    22   B10  CS        Touch
//  12   T_MOSI   grn    25   B15  SPI2 MOSI Touch
//  13   T_MISO   blu    24   B14  SPI2 MISO Touch
//  14   T_IRQ    blk    21   B1   IRQ       Touch

var
    touch, tMod = require("XPT2046");

function fInt(i,l) { return ("        " + i).substr(-l); }

function onInit() {
      SPI2.setup({sck:B13, miso:B14, mosi:B15, baud: 2000000});
      touch = tMod.connect(
          // spi, cs, irq, callback, calc
          SPI2, B10, B1, function(x, y) {
            if (x !== undefined) {
              console.log(fInt(x,4),fInt(y,4));
            }
          }, function(yr, xr, d) {
            // calc function - converts raw data to x / y coordinates;
            // scale and offset values calculated using calibration 
            // markers and default calc function. For more details see
            // http://forum.espruino.com/conversations/292641 - Touchscreen
//          return [ Math.round(xr / xsc + xos) // / x scale per pixel + x offset
//                 , Math.round(yr / ysc + yos) // / y scale per pixel + y offset
            return [ Math.round(xr / -121.44          + 259.70685111989) 
                   , Math.round(yr /   88.90357142857 + -19.78130398103)
                   ];
          }).listen();
}

onInit();

/*

Related console output (tapping markers on screen):

***NOTE*** the last 4 lines which lay outside of the display, because the 
touch screen has a pretty sizable porch at the bottom.

 1v86 Copyright 2016 G.Williams
>echo(0);
=undefined
  21   18
  22   19
  22   18
 223   20
 222   19
 121  162
 118  160
 121  162
  18  303
  19  303
  17  301
 219  303
 219  300
 220  300
 220  302
 130  333
 127  324
 128  328
 126  324
 130  333
 127  324
 128  328
 126  324
>

 */